#ifndef _ANTHOCNET_CONSTANTS_H_
#define _ANTHOCNET_CONSTANTS_H_

typedef char BOOLEAN;

#define PRINT_DELAY_DETAILS FALSE
#define ANTHOCNET_TRACE_PACKETS   FALSE
#define FROM_HELLO 0
#define TRACE   if(ANTHOCNET_TRACE_PACKETS)fprintf
#define secSimTime(t)   ((clocktype)((t)*SECOND))
#define simTimeSec(t)   (((double)(t))/SECOND) //convert a clocktype variable to a double, and give the time in seconds
#define TIME_UNDEFINED   CLOCKTYPE_MAX

#define ANTHOCNET_DEBUG   FALSE
#define ANTHOCNET_DEBUG2  FALSE
#define FPRINTF   if(ANTHOCNET_DEBUG) fprintf
#define FPRINTF2  if(ANTHOCNET_DEBUG2) fprintf

#define nextHopsList(RTDestEntry) (((ANTS01RTDest*)RTDestEntry->data)->nextHops)

#define mem_error(ptr, msg) \
        if (ptr == NULL)\
        {\
               ERROR_Assert(FALSE, msg);\
               abort();\
        }

#define mem_error2(ptr1, ptr2, msg) \
        if (ptr1 == NULL || ptr2 == NULL)\
        {\
               ERROR_Assert(FALSE, msg);\
               abort();\
        }

#define ANTHOCNET_NO_DATA   -1 //used to create list entries without data

#define ANTHOCNET_PRINT_PHEROMONE_CHANGE FALSE
#define ANTHOCNET_PRINT_HOP_CHOSEN FALSE

#define ANTHOCNET_TRACE_PACKETS   FALSE

#define ANTHOCNET_IDS_NUMBER   50 //Number of ant ids remembered per destination
#define ANTHOCNET_NO_MORE_ENTRIES -1

#define ANTHOCNET_HOP_LATENCY (0.003 * SECOND)
#define ANTHOCNET_DEST_NOT_USED 0
#define ANTHOCNET_MAX_UNUSED_TIME (15 * SECOND)
#define ANTHOCNET_MAX_WAITING_TIME (10 * SECOND)
#define ANTHOCNET_MAX_TIME_TO_BOOTSTRAP (3 * SECOND)
#define ANTHOCNET_MAX_BOOTSTRAPPED_PHEROMONE_AGE (3 * SECOND)
#define ANTHOCNET_ACTIVE_DESTINATION 128

#define ANTHOCNET_MAX_DISCRETE_PHEROMONE 65536
#define ANTHOCNET_UNIT_DISCRETE_PHEROMONE (3.0 / ANTHOCNET_MAX_DISCRETE_PHEROMONE)

#define ANTHOCNET_NUMBER_OF_MSG_IDS 100

#define ANTHOCNET_nextHopsList(RTDestEntry) (((ANTHOCNETRTDest*)RTDestEntry->data)->nextHops)


#endif

#ifndef _ANTNET_CONSTANTS_H_
#define _ANTNET_CONSTANTS_H_

#define ANTNET_PRINT_PHEROMONE_CHANGE FALSE
#define ANTNET_PRINT_HOP_CHOSEN FALSE

#endif
